var CustomGeometry = {
	ResizeScreen: function ()
	{
		var Width=1192, Height=1170, Left=728, Top=0;
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
		if(oPrefs.prefHasUserValue("customgeometry.options.width"))
			Width = oPrefs.getIntPref("customgeometry.options.width");
		if(oPrefs.prefHasUserValue("customgeometry.options.height"))
			Height = oPrefs.getIntPref("customgeometry.options.height");
		if(oPrefs.prefHasUserValue("customgeometry.options.left"))
			Left = oPrefs.getIntPref("customgeometry.options.left");
		if(oPrefs.prefHasUserValue("customgeometry.options.top"))
			Top = oPrefs.getIntPref("customgeometry.options.top");
		
		CustomGeometry.SetGeometry(Width, Height, Left, Top);
	},

	CustomGeometryInitialize: function()
	{
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
		CustomGeometry.UpdateMenu();
	},


	//  Update the list of sizes.
	UpdateMenu: function (ResizeDefault)
	{
		if (ResizeDefault==null)
			ResizeDefault = 1;
		
		try
		{
			//Prefs
			var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
			var GeometryStore = '';
			var ContextMenu;
			var GeometrySplit;
			var GeometryArray;
			var GeometryIndex;
			var Name;
			var Width;
			var Height;
			var Left;
			var Top;
			var OneOption;
			var CGImage;
			
			
			//  Don't pregress until we have access to the Context Menu.
			ContextMenu = document.getElementById("Customgeometry-context");
			
			if (ContextMenu == null)
			{
				self.setTimeout('CustomGeometry.CustomGeometryInitialize();', 2000);
				return;
			}
			
			
			
			//Prefill
			if(oPrefs.prefHasUserValue("customgeometry.options.list"))
				GeometryStore = oPrefs.getCharPref("customgeometry.options.list");
			
			if (GeometryStore == '')
				GeometryStore = "Default^1192^1170^728^0";
			
			GeometrySplit = GeometryStore.split('~');
			
			//  Clear the menu.
			while (ContextMenu.hasChildNodes())
			{
				ContextMenu.removeChild(ContextMenu.childNodes[0]);
			}
			
			OneOption = document.createElement("menuitem");
			OneOption.setAttribute('label', 'Show Current Geometry');
			OneOption.setAttribute('oncommand', 'CustomGeometry.ShowCurrentGeometry();');
			ContextMenu.appendChild(OneOption);
			
			for (GeometryIndex=0; GeometryIndex<GeometrySplit.length; GeometryIndex++)
			{
				GeometryArray = GeometrySplit[GeometryIndex].split('^');
				Name = GeometryArray[0];
				Width = GeometryArray[1];
				Height = GeometryArray[2];
				Left = GeometryArray[3];
				Top = GeometryArray[4];
				
				OneOption = document.createElement("menuitem");
				OneOption.setAttribute('label', 'Set: ' + Name);
				OneOption.setAttribute('oncommand', 'CustomGeometry.SetGeometry(' + Width + ', ' + Height + ', ' + Left + ', ' + Top + ');');
				ContextMenu.appendChild(OneOption);
				
				if (CustomGeometry.MatchWindow(Name))
				{
					if (ResizeDefault != 0)
						CustomGeometry.SetGeometry(Width, Height, Left, Top);
					
					CGImage = document.getElementById("customgeometry-panel");
					CGImage.setAttribute('onclick', 'CustomGeometry.UpdateMenu(0);  if (event.button == 0) CustomGeometry.SetGeometry(' + Width + ', ' + Height + ', ' + Left + ', ' + Top + ');');
				}
			}
		} catch(err) { alert(err); }
	},


	//  This returns 1 if the given window name is contained within the title of the
	//  current application window.  This returns 0 otherwise.
	MatchWindow: function(WindowName)
	{
		//  The "Default" entry always matches.
		if (WindowName.toLowerCase() == "default")
			return(1);
		
		if (document.title.indexOf(WindowName) >= 0)
			return(1);
		else
			return(0);
	},


	ShowCurrentGeometry: function()
	{
		alert("Current Geometry\n\nWidth: " + window.outerWidth + "\nHeight: " + window.outerHeight + "\nLeft: " + window.screenX + "\nTop: " + window.screenY);
	},


	SetGeometry: function(Width, Height, Left, Top)
	{
		window.moveTo(Left, Top);
		window.resizeTo(Width, Height);
	}
}

self.setTimeout('CustomGeometry.CustomGeometryInitialize();', 2000);

